#include "my_sqrt.h"
#include <stdexcept>

double my_abs(double x)
{
    return x < 0 ? -x : x;
}

double my_sqrt(double x, double eps)
{
    if (x < 0)
        throw std::runtime_error("my_sqrt: given negative number");

    double guess = 1;

    // The Babylonian method for computing a squareroot:
    while (my_abs(guess - x/guess) >= eps)
        guess = (guess + x/guess) / 2;

    return guess;
}
